VERSION 5.00
Begin VB.Form frmMastermind 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Mastermind"
   ClientHeight    =   11130
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4155
   Icon            =   "frmMastermind.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   11130
   ScaleWidth      =   4155
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.PictureBox picPin 
      Appearance      =   0  '2D
      BackColor       =   &H00E0E0E0&
      ForeColor       =   &H80000008&
      Height          =   650
      Index           =   4
      Left            =   2700
      ScaleHeight     =   615
      ScaleWidth      =   615
      TabIndex        =   3
      Top             =   150
      Visible         =   0   'False
      Width           =   650
   End
   Begin VB.PictureBox picPin 
      Appearance      =   0  '2D
      BackColor       =   &H00E0E0E0&
      ForeColor       =   &H80000008&
      Height          =   650
      Index           =   3
      Left            =   1875
      ScaleHeight     =   615
      ScaleWidth      =   615
      TabIndex        =   2
      Top             =   150
      Visible         =   0   'False
      Width           =   650
   End
   Begin VB.PictureBox picPin 
      Appearance      =   0  '2D
      BackColor       =   &H00E0E0E0&
      ForeColor       =   &H80000008&
      Height          =   650
      Index           =   1
      Left            =   225
      ScaleHeight     =   615
      ScaleWidth      =   615
      TabIndex        =   0
      Top             =   150
      Visible         =   0   'False
      Width           =   650
   End
   Begin VB.PictureBox picPin 
      Appearance      =   0  '2D
      BackColor       =   &H00E0E0E0&
      ForeColor       =   &H80000008&
      Height          =   650
      Index           =   2
      Left            =   1050
      ScaleHeight     =   615
      ScaleWidth      =   615
      TabIndex        =   1
      Top             =   150
      Visible         =   0   'False
      Width           =   650
   End
   Begin VB.Line Line1 
      X1              =   225
      X2              =   4000
      Y1              =   950
      Y2              =   950
   End
   Begin VB.Shape BingoBox 
      FillColor       =   &H00E0E0E0&
      FillStyle       =   0  'Ausgefllt
      Height          =   240
      Index           =   4
      Left            =   3755
      Shape           =   4  'Gerundetes Rechteck
      Top             =   495
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Shape BingoBox 
      FillColor       =   &H00E0E0E0&
      FillStyle       =   0  'Ausgefllt
      Height          =   240
      Index           =   3
      Left            =   3480
      Shape           =   4  'Gerundetes Rechteck
      Top             =   495
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Shape BingoBox 
      FillColor       =   &H00E0E0E0&
      FillStyle       =   0  'Ausgefllt
      Height          =   240
      Index           =   2
      Left            =   3755
      Shape           =   4  'Gerundetes Rechteck
      Top             =   225
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Shape BingoBox 
      FillColor       =   &H00E0E0E0&
      FillStyle       =   0  'Ausgefllt
      Height          =   240
      Index           =   1
      Left            =   3480
      Shape           =   4  'Gerundetes Rechteck
      Top             =   225
      Visible         =   0   'False
      Width           =   240
   End
End
Attribute VB_Name = "frmMastermind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Dieses Programm ist urheberrechtlich geschtzt
' und darf nur fr private und nicht kommerzielle
' Zwecke verwendet werden!
'
' Programm: Mastermind
' Autoren: Daniel Berger, Alexander Kopatz
' Version: 1.0
' Datum: 2011-07-31
'

Option Explicit

Private Const MaxRounds As Integer = 10 'Maximale Anzahl an Runden
Private Const MaxPins As Integer = 4 'Maximale Anzahl an Spielsteinen (Pins) pro Runde

Private iZhler As Integer
Private iPin As Integer

'--- Globaler Speicher fr Farben und Ergebnisse ---'

Private Type typRunde
   iFarbe(1 To 4) As Integer 'Welche Farbe hat welcher Stein
   iTreffer(1 To 4) As Integer 'diese Treffer wurden erzielt
End Type

Private Runde() As typRunde

'--- Zwischenspeicher fr Runde und Pin ---'

Private iBuffRunde As Integer
Private iBuffPin As Integer

Private Sub CreateSpielfeld()

   '=== Diese Funktion generiert dynamisch ein Spielfeld ==='

   For iZhler = 1 To MaxRounds
   
      For iPin = 1 To MaxPins
         
         '=== leere Pins fr das Spielfeld laden ==='
         
         Load Me.picPin(iZhler * 10 + iPin)
            'Spielfelder werden erst zur Laufzeit dynamisch erstellt
         
         With Me.picPin(Me.picPin.UBound)
            .Top = iZhler * 750 + 350
            .Left = iPin * 825 - 600
            .Visible = True
         End With
         
         '=== leere BingoBoxen laden ==='
         
         Load Me.BingoBox(iZhler * 10 + iPin)
         
         With Me.BingoBox(Me.BingoBox.UBound)
         
            If iPin <= 2 Then
               'Bei BingoBox 1 und 2 wird ein anderer Top-Wert
               'bentigt als bei BingoBox 3 und 4
               .Top = iZhler * 750 + 400
                  
            Else
               Me.BingoBox(Me.BingoBox.UBound).Top = iZhler * 750 + 675
            
            End If
            
               If iPin Mod 2 = 0 Then .Left = .Left + 250
                  'Alle geraden BingoBoxen (2 und 4) werden zustzlich
                  'um 250 nach Rechts verschoben um ins Bild zu passen
            
            .Visible = True
         
         End With
         
      Next
      
   Next
   
   Me.Height = Me.picPin(Me.picPin.UBound).Top + 1250

End Sub

Private Sub GetRndFirstSet()

   '=== Funktion erzeugt die erste zufllige Farbenreihe ==='

   Randomize Timer
      'Zufallsgenerator wird mit dem Timer-Counter initialisiert um
      'nicht bei jeder Spielrunde die selben Zufallszahlen zu erhalten.
      
   ReDim Runde(1)
   
   For iPin = 1 To MaxPins
   
      Runde(0).iFarbe(iPin) = Int((Rnd * 6) + 1)
      Runde(1).iFarbe(iPin) = 7

   Next
   
End Sub

Private Function GetColor(ByRef iFarbe As Integer) As Long

   Select Case iFarbe
      
      Case 1: GetColor = RGB(&HFF, 0, 0) 'rot
      Case 2: GetColor = RGB(0, &HFF, 0) 'grn
      Case 3: GetColor = RGB(0, 0, &HFF) 'blau
      Case 4: GetColor = RGB(&HFF, &HFF, 0) 'gelb
      Case 5: GetColor = RGB(&HFF, &HAF, 0) 'orange
      Case 6: GetColor = RGB(&HAB, 0, &HFF) 'lila
      Case 7: GetColor = vbWhite
      
      Case 0: GetColor = &HE0E0E0
   
   End Select

End Function

Private Sub PrintSpielfeld()

Dim iCounter As Long

'--- Treffer zurcksetzen

   For iZhler = 0 To UBound(Runde)
      For iPin = 1 To MaxPins
         Me.BingoBox(iZhler * 10 + iPin).Tag = "0"
         Me.BingoBox(iZhler * 10 + iPin).FillColor = &HE0E0E0
      Next
   Next

'--- Normale Steine und Treffer zeichnen

   For iZhler = 0 To UBound(Runde)
      
      For iPin = 1 To MaxPins 'Normale Spielsteine (Pins) zeichnen
         Me.picPin(iZhler * 10 + iPin).BackColor = GetColor(Runde(iZhler).iFarbe(iPin))
      Next
      
   'Hier werden die Trefferfelder (BingoBoxen) gezeichnet. Um keinen Hinweis
   'auf die Position der Pins zu heben werden zunchst die Volltreffer gezeichnet
   'und erst danach die Farbtreffer.
      
         For iPin = 1 To MaxPins 'Volltreffer zeichnen
            If Runde(iZhler).iTreffer(iPin) = 1 Then
               
               For iCounter = 1 To MaxPins
                  
                  With Me.BingoBox(iZhler * 10 + iCounter)
                     If .Tag = "0" Then
                        .FillColor = GetColor(1)
                        .Tag = "1"
                           
                           If iCounter = 4 Then
                              Victory
                              Exit Sub
                           End If
                           
                        Exit For
                        
                     End If
                  End With
                  
               Next
               
            End If
         Next
         
         For iPin = 1 To MaxPins 'Farbtreffer zeichnen
            If Runde(iZhler).iTreffer(iPin) = 2 Then
               
               For iCounter = 1 To MaxPins
                  
                  With Me.BingoBox(iZhler * 10 + iCounter)
                     If .Tag = "0" Then
                        .FillColor = GetColor(2)
                        .Tag = "2"
                        
                        Exit For
                        
                     End If
                  End With
                  
               Next
               
            End If
         Next
   
   Next

End Sub

Private Sub RundeBeenden()

'--- Prfen ob alle Felder ausgefllt wurden

   For iPin = 1 To MaxPins
      If Runde(UBound(Runde)).iFarbe(iPin) = 7 Then: Exit Sub
   Next


'--- Die Treffer prfen

   For iZhler = 1 To MaxPins
      If Runde(0).iFarbe(iZhler) = Runde(UBound(Runde)).iFarbe(iZhler) Then
         Runde(UBound(Runde)).iTreffer(iZhler) = 1 'Volltreffer
      Else
         For iPin = 1 To MaxPins
            If Runde(UBound(Runde)).iTreffer(iPin) = 0 Then
               If Runde(0).iFarbe(iZhler) = Runde(UBound(Runde)).iFarbe(iPin) Then
                  Runde(UBound(Runde)).iTreffer(iPin) = 2: Exit For 'Farbtreffer
               End If
            End If
         Next
      End If
   Next
   

'--- Nchste Spielfeldrunde aktivieren

   If UBound(Runde) < MaxRounds Then
   
      ReDim Preserve Runde(UBound(Runde) + 1)
      
      For iPin = 1 To MaxPins

         Runde(UBound(Runde)).iFarbe(iPin) = 7
   
      Next
      
   Else
      For iZhler = 1 To MaxPins
         picPin(iZhler).Visible = True
      Next
   
   End If

End Sub

Private Sub Victory()

   Beep
   MsgBox "Herzlichen Glckwunsch! Sie haben diese Partie in Runde " & UBound(Runde) - 1 & " gewonnen!", vbInformation, "Sieg!"
   
   For iZhler = 0 To UBound(Runde)
      For iPin = 1 To MaxPins
         Me.picPin(iZhler * 10 + iPin).Enabled = False
            'Alle Felder sperren...
      Next
   Next
   
   For iZhler = 1 To MaxPins
      picPin(iZhler).Visible = True
   Next

End Sub

Private Sub Form_DblClick()

   If Me.picPin(11).Enabled = False Then Exit Sub
      'Spiel bereits gewonnen...

 RundeBeenden
 PrintSpielfeld

End Sub

Private Sub Form_Load()

   'Hier geht's los! :-)

   CreateSpielfeld
   GetRndFirstSet
   PrintSpielfeld

End Sub
Private Sub picPin_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

   iBuffRunde = Int(Index / 10) 'Ermittelt die aktuelle Runde
   iBuffPin = Index Mod 10 'Ermittelt den aktuellen Pin
   
   If iBuffRunde = UBound(Runde) Then
      'Abfrage stellt sicher, dass immer nur die gerade
      'aktive Runde bearbeitet werden kann (darf).
   
      With Runde(iBuffRunde)
      
         If Button = 1 Then
            .iFarbe(iBuffPin) = .iFarbe(iBuffPin) + 1
         Else
            .iFarbe(iBuffPin) = .iFarbe(iBuffPin) - 1
         End If
            
         If .iFarbe(iBuffPin) >= 7 Then .iFarbe(iBuffPin) = 1
         If .iFarbe(iBuffPin) <= 0 Then .iFarbe(iBuffPin) = 6
      
      End With
      
      picPin(Index).BackColor = GetColor(Runde(iBuffRunde).iFarbe(iBuffPin))
      
   End If

End Sub

